Bug 78403 - RFE: include valgrind
RFE: include valgrind
Product: Red Hat Linux
Classification: Retired
Component: distribution (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
Depends On:
  Show dependency treegraph
Reported: 2002-11-22 07:29 EST by Miloslav Trmac
Modified: 2014-03-16 22:32 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2004-07-21 11:10:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
valgrind 1.04 packaged for RedHat 8 (536.60 KB, application/octet-stream)
2002-11-22 10:33 EST, Bill Rugolsky, Jr.
no flags Details
kcachegrind packaged for RedHat 8 (966.82 KB, application/octet-stream)
2002-11-22 10:35 EST, Bill Rugolsky, Jr.
no flags Details

  None (edit)
Description Miloslav Trmac 2002-11-22 07:29:15 EST
valgrind (http://developer.kde.org/~sewardj/) is an excellent program
correctness checker, including checking for memory leaks/usage of
freed memory and usage of uninitialized values. I would like to humbly
propose its inclusion in the upcoming RHL release.

There are probably some space constraints, but I'd be happy
to sacrifice all three of of ElectricFence, njamd and memprof
to get valgrind. The only disadvantage of valgrind I can think
of is that it is currently IA-32 (x86) only.
Comment 1 Bill Rugolsky, Jr. 2002-11-22 10:33:43 EST
Created attachment 86064 [details]
valgrind 1.04 packaged for RedHat 8
Comment 2 Bill Rugolsky, Jr. 2002-11-22 10:35:40 EST
Created attachment 86065 [details]
kcachegrind packaged for RedHat 8
Comment 3 Bill Rugolsky, Jr. 2002-11-22 10:38:43 EST
I attached my SRPMS for valgrind and kcachegrind. valgrind has one glaring
problem: it access a glibc private interface.  That needs to be fixed.

The packages also lack BuildRequires.
Comment 4 Bill Nottingham 2002-11-22 12:06:21 EST
We'd like to. But we can't. Lots'o'patent issues.
Comment 5 Pádraig Brady 2003-12-09 04:53:12 EST
What Patent issues? Hmm just noticed that Mr. Seward
(who also wrote bzip2 fair dues to him) is currently
a contractor for Microsoft? Or is google lying to me?
Comment 6 Pádraig Brady 2004-07-21 11:03:55 EDT
Google lied :-)
He's a compiler writer at ARM, Cambridge, UK.
I still would like to know what Patent issues there are?
This is the first pertinent link from google.
Comment 7 Bill Nottingham 2004-07-21 11:10:58 EDT
In rawhide now.
Comment 8 William Cohen 2004-07-22 16:41:59 EDT
Rational has some patents for using binary rewrites for memory checks.
This is the mechanism used in Purify their memory checking tool.  IBM
bought Rational in December 2002.

This is one of the patents:

Comment 9 Mark Schreiber 2004-08-08 14:34:55 EDT
Unfortunately, many pieces of software, including ones crucial to the
Red Hat/Fedora distribution (such as the Linux kernel), almost
certainly infringe upon software patents.  This is not unique to open
source -- it is simply no longer possible to write significant
software packages without infringing upon software patents.  Any
decent software engineer can easily go to the USPTO and search for
"computer" and recognize many widely-used techniques that have been

In this case, we are fortunate that IBM is the patent holder.  Given
that valgrind is probably the most powerful free memory debugging tool
under Linux, and Red Hat/Fedora cannot currently include valgrind, it
seems that it might be worthwhile to request a waiver from IBM for
GPLed software on this patent.  I cannot see IBM likely to get much
good out of using the patent against GPLed software, and there are
clearly a number of Red Hat users that would get a good deal of good
out of being able to use valgrind.

Such a move for IBM would not, at least in the immediate sense, reduce
the utility of the patent for IBM's defensive measures -- anyone
likely to sue IBM has probably made many releases of their own
infringing software in the past under a license other than the GPL. 
Even if an attacker's infringing software was immediately GPLed, IBM
would have a case.
Comment 10 Joshua Jensen 2004-12-15 16:12:59 EST
valgrind is now in Fedora Core 3

Note You need to log in before you can comment on or make changes to this bug.